using QuantumCumulants
using QuPhys
using ModelingToolkit, OrdinaryDiffEq

using PyPlot

using BenchmarkTools
using ProgressMeter

using Statistics, StatsBase

using JLD
using Glob

#Functions
squeeze(a::AbstractArray) = dropdims(a, dims = tuple(findall(size(a) .== 1)...))
dropmean(A; dims=:) = dropdims(mean(A; dims=dims); dims=dims)

function LogRange(start, last, count)
    rg = map(exp10, LinRange(log10(start), log10(last), count))
    rg[1] = start
    rg[end] = last
    rg
end

#Plot parameters
rcParams = PyPlot.PyDict(PyPlot.matplotlib."rcParams")

#Plot configurations
font_size   = 20
letter_size = 22
label_size  = 22
title_font  = 26
legend_size = 19

PyPlot.matplotlib[:rc]("font", family="serif", size=font_size)
PyPlot.matplotlib[:rc]("text", usetex=true)

rcParams["figure.figsize"] = (6,3.6)
rcParams["figure.dpi"]     = 100


rcParams["lines.linewidth"]     = 2
rcParams["axes.labelsize"]      = label_size
rcParams["xtick.minor.visible"] = true
rcParams["xtick.major.size"]    = 6
rcParams["xtick.minor.size"]    = 3
rcParams["xtick.major.width"]   = 1.1
rcParams["xtick.minor.width"]   = 0.55
rcParams["xtick.direction"]     = "out"
rcParams["ytick.minor.visible"] = true
rcParams["ytick.major.size"]    = 6
rcParams["ytick.minor.size"]    = 3
rcParams["ytick.major.width"]   = 1.1
rcParams["ytick.minor.width"]   = 0.55
rcParams["ytick.direction"]     = "out"
rcParams["legend.fontsize"]     = legend_size
rcParams["axes.formatter.limits"] = -4, 4

marker_sz   = 10
width_plot  = 6
heigth_plot = 3.6

1;